package buildcraft.builders.filler;

import net.minecraft.nbt.NBTTagCompound;

import buildcraft.api.filler.FillerManager;
import buildcraft.api.filler.IFillerPattern;

import buildcraft.lib.net.PacketBufferBC;
import buildcraft.lib.statement.StatementType;

import buildcraft.builders.BCBuildersStatements;

public class FillerType extends StatementType<IFillerPattern> {
    public static final FillerType INSTANCE = new FillerType();

    private FillerType() {
        super(IFillerPattern.class, BCBuildersStatements.PATTERN_NONE);
    }

    @Override
    public IFillerPattern readFromNbt(NBTTagCompound nbt) {
        String kind = nbt.func_74779_i("kind");
        IFillerPattern pattern = FillerManager.registry.getPattern(kind);
        if (pattern == null) {
            return defaultStatement;
        }
        return pattern;
    }

    @Override
    public NBTTagCompound writeToNbt(IFillerPattern slot) {
        NBTTagCompound nbt = new NBTTagCompound();
        nbt.func_74778_a("kind", slot.getUniqueTag());
        return nbt;
    }

    @Override
    public IFillerPattern readFromBuffer(PacketBufferBC buffer) {
        String kind = buffer.readString();
        IFillerPattern pattern = FillerManager.registry.getPattern(kind);
        if (pattern == null) {
            return defaultStatement;
        }
        return pattern;
    }

    @Override
    public void writeToBuffer(PacketBufferBC buffer, IFillerPattern slot) {
        buffer.func_180714_a(slot.getUniqueTag());
    }
}
